Index: libcfa/src/concurrency/monitor.cfa
===================================================================
--- libcfa/src/concurrency/monitor.cfa	(revision c5e1aa6010a41c286b6f179da6348411941b89b2)
+++ libcfa/src/concurrency/monitor.cfa	(revision 579427b5dae492c357e172f3e2f17af585f77f00)
@@ -9,7 +9,7 @@
 // Author           : Thierry Delisle
 // Created On       : Thd Feb 23 12:27:26 2017
-// Last Modified By : Kyoung Seo
-// Last Modified On : Thd Jan 16 12:59:00 2025
-// Update Count     : 73
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Fri Apr 25 07:20:22 2025
+// Update Count     : 80
 //
 
@@ -78,5 +78,5 @@
 	__spinlock_t * locks[count];							/* We need to pass-in an array of locks to BlockInternal */
 
-#define monitor_save    save   ( monitors, count, locks, recursions, masks )
+#define monitor_save save ( monitors, count, locks, recursions, masks )
 #define monitor_restore restore( monitors, count, locks, recursions, masks )
 
@@ -95,14 +95,14 @@
 	if ( unlikely(0 != (0x1 & (uintptr_t)this->owner)) ) {
 		abort( "Attempt by thread \"%.256s\" (%p) to access joined monitor %p.", thrd->self_cor.name, thrd, this );
-	} else if ( !this->owner ) {
+	} else if ( ! this->owner ) {
 		// No one has the monitor, just take it
 		__set_owner( this, thrd );
 
-		__cfaabi_dbg_print_safe( "Kernel :  mon is free \n" );
+		__cfaabi_dbg_print_safe( "Kernel : mon is free \n" );
 	} else if ( this->owner == thrd) {
 		// We already have the monitor, just note how many times we took it
 		this->recursion += 1;
 
-		__cfaabi_dbg_print_safe( "Kernel :  mon already owned \n" );
+		__cfaabi_dbg_print_safe( "Kernel : mon already owned \n" );
 	} else if ( is_accepted( this, group) ) {
 		// Some one was waiting for us, enter
@@ -112,7 +112,7 @@
 		reset_mask( this );
 
-		__cfaabi_dbg_print_safe( "Kernel :  mon accepts \n" );
+		__cfaabi_dbg_print_safe( "Kernel : mon accepts \n" );
 	} else {
-		__cfaabi_dbg_print_safe( "Kernel :  blocking \n" );
+		__cfaabi_dbg_print_safe( "Kernel : blocking \n" );
 
 		// Some one else has the monitor, wait in line for it
@@ -124,5 +124,5 @@
 		park();
 
-		__cfaabi_dbg_print_safe( "Kernel : %10p Entered  mon %p\n", thrd, this);
+		__cfaabi_dbg_print_safe( "Kernel : %10p Entered mon %p\n", thrd, this);
 
 		/* paranoid */ verifyf( active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
@@ -130,5 +130,5 @@
 	}
 
-	__cfaabi_dbg_print_safe( "Kernel : %10p Entered  mon %p\n", thrd, this);
+	__cfaabi_dbg_print_safe( "Kernel : %10p Entered mon %p\n", thrd, this);
 
 	/* paranoid */ verifyf( active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
@@ -152,5 +152,5 @@
 
 
-	if ( !this->owner ) {
+	if ( ! this->owner ) {
 		__cfaabi_dbg_print_safe( "Kernel : Destroying free mon %p\n", this);
 
@@ -159,9 +159,9 @@
 
 		/* paranoid */ verifyf( active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
-		/* paranoid */ verify( !is_thrd || thrd->state == Halted || thrd->state == Cancelled );
+		/* paranoid */ verify( ! is_thrd || thrd->state == Halted || thrd->state == Cancelled );
 
 		unlock( this->lock );
 		return;
-	} else if ( this->owner == thrd && !join) {
+	} else if ( this->owner == thrd && ! join) {
 		// We already have the monitor... but where about to destroy it so the nesting will fail
 		// Abort!
@@ -179,5 +179,5 @@
 
 		/* paranoid */ verifyf( active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
-		/* paranoid */ verify( !is_thrd || thrd->state == Halted || thrd->state == Cancelled );
+		/* paranoid */ verify( ! is_thrd || thrd->state == Halted || thrd->state == Cancelled );
 
 		unlock( this->lock );
@@ -186,5 +186,5 @@
 
 	// The monitor is busy, if this is a thread and the thread owns itself, it better be active
-	/* paranoid */ verify( !is_thrd || this->owner != thrd || (thrd->state != Halted && thrd->state != Cancelled) );
+	/* paranoid */ verify( ! is_thrd || this->owner != thrd || (thrd->state != Halted && thrd->state != Cancelled) );
 
 	__lock_size_t count = 1;
@@ -192,5 +192,5 @@
 	__monitor_group_t group = { &this, 1, func };
 	if ( is_accepted( this, group) ) {
-		__cfaabi_dbg_print_safe( "Kernel :  mon accepts dtor, block and signal it \n" );
+		__cfaabi_dbg_print_safe( "Kernel : mon accepts dtor, block and signal it \n" );
 
 		// Wake the thread that is waiting for this
@@ -220,5 +220,5 @@
 		return;
 	} else {
-		__cfaabi_dbg_print_safe( "Kernel :  blocking \n" );
+		__cfaabi_dbg_print_safe( "Kernel : blocking \n" );
 
 		wait_ctx( thrd, 0 )
@@ -254,5 +254,5 @@
 	// it means we don't need to do anything
 	if ( this->recursion != 0) {
-		__cfaabi_dbg_print_safe( "Kernel :  recursion still %d\n", this->recursion);
+		__cfaabi_dbg_print_safe( "Kernel : recursion still %d\n", this->recursion);
 		unlock( this->lock );
 		return;
@@ -264,5 +264,5 @@
 	// Check the new owner is consistent with who we wake-up
 	// new_owner might be null even if someone owns the monitor when the owner is still waiting for another monitor
-	/* paranoid */ verifyf( !new_owner || new_owner == this->owner, "Expected owner to be %p, got %p (m: %p)", new_owner, this->owner, this );
+	/* paranoid */ verifyf( ! new_owner || new_owner == this->owner, "Expected owner to be %p, got %p (m: %p)", new_owner, this->owner, this );
 
 	// We can now let other threads in safely
@@ -270,5 +270,5 @@
 
 	//We need to wake-up the thread
-	/* paranoid */ verifyf( !new_owner || new_owner == this->owner, "Expected owner to be %p, got %p (m: %p)", new_owner, this->owner, this );
+	/* paranoid */ verifyf( ! new_owner || new_owner == this->owner, "Expected owner to be %p, got %p (m: %p)", new_owner, this->owner, this );
 	unpark( new_owner );
 }
@@ -280,5 +280,5 @@
 			abort( "Destroyed monitor %p has inconsistent owner, expected %p got %p.\n", this, active_thread(), this->owner);
 		}
-		if ( this->recursion != 1  && !join ) {
+		if ( this->recursion != 1 && ! join ) {
 			abort( "Destroyed monitor %p has %d outstanding nested calls.\n", this, this->recursion - 1);
 		}
@@ -317,5 +317,5 @@
 
 	// Unpark the next owner if needed
-	/* paranoid */ verifyf( !new_owner || new_owner == this->owner, "Expected owner to be %p, got %p (m: %p)", new_owner, this->owner, this );
+	/* paranoid */ verifyf( ! new_owner || new_owner == this->owner, "Expected owner to be %p, got %p (m: %p)", new_owner, this->owner, this );
 	/* paranoid */ verify( ! __preemption_enabled() );
 	/* paranoid */ verify( thrd->state == Halted );
@@ -424,15 +424,15 @@
 
 static void ?{}(__condition_criterion_t & this ) with( this ) {
-	ready  = false;
+	ready = false;
 	target = 0p;
-	owner  = 0p;
-	next   = 0p;
+	owner = 0p;
+	this.next = 0p;
 }
 
 static void ?{}(__condition_criterion_t & this, monitor$ * target, __condition_node_t & owner ) {
-	this.ready  = false;
+	this.ready = false;
 	this.target = target;
-	this.owner  = &owner;
-	this.next   = 0p;
+	this.owner = &owner;
+	this.next = 0p;
 }
 
@@ -525,5 +525,5 @@
 	for ( i; count ) {
 		__condition_criterion_t * crit = &node->criteria[i];
-		assert( !crit->ready );
+		assert( ! crit->ready );
 		push( crit->target->signal_stack, crit );
 	}
@@ -536,5 +536,5 @@
 
 bool signal_block( condition & this ) libcfa_public {
-	if ( !this.blocked.head ) { return false; }
+	if ( ! this.blocked.head ) { return false; }
 
 	//Check that everything is as expected
@@ -571,5 +571,5 @@
 	// WE WOKE UP
 
-	__cfaabi_dbg_print_buffer_local( "Kernel :   signal_block returned\n" );
+	__cfaabi_dbg_print_buffer_local( "Kernel : signal_block returned\n" );
 
 	//We are back, restore the masks and recursions
@@ -581,5 +581,5 @@
 // Access the user_info of the thread waiting at the front of the queue
 uintptr_t front( condition & this ) libcfa_public {
-	verifyf( !is_empty(this),
+	verifyf( ! is_empty(this),
 		"Attempt to access user data on an empty condition.\n"
 		"Possible cause is not checking if the condition is empty before reading stored data."
@@ -624,13 +624,13 @@
 	{
 		// Check if the entry queue
-		thread$ * next; int index;
-		[next, index] = search_entry_queue( mask, monitors, count );
-
-		if ( next ) {
+		thread$ * nxt; int index;
+		[nxt, index] = search_entry_queue( mask, monitors, count );
+
+		if ( nxt ) {
 			*mask.accepted = index;
 			__acceptable_t& accepted = mask[index];
 			if ( accepted.is_dtor ) {
 				__cfaabi_dbg_print_buffer_local( "Kernel : dtor already there\n" );
-				verifyf( accepted.size == 1,  "ERROR: Accepted dtor has more than 1 mutex parameter." );
+				verifyf( accepted.size == 1, "ERROR: Accepted dtor has more than 1 mutex parameter." );
 
 				monitor$ * mon2dtor = accepted[0];
@@ -651,5 +651,5 @@
 				monitor_save;
 
-				__cfaabi_dbg_print_buffer_local( "Kernel :  baton of %"PRIdFAST16" monitors : ", count );
+				__cfaabi_dbg_print_buffer_local( "Kernel : baton of %"PRIdFAST16" monitors : ", count );
 				#ifdef __CFA_DEBUG_PRINT__
 					for ( i; count ) {
@@ -660,5 +660,5 @@
 
 				// Set the owners to be the next thread
-				__set_owner( monitors, count, next );
+				__set_owner( monitors, count, nxt );
 
 				// unlock all the monitors
@@ -666,5 +666,5 @@
 
 				// unpark the thread we signalled
-				unpark( next );
+				unpark( nxt );
 
 				//Everything is ready to go to sleep
@@ -741,11 +741,11 @@
 	/* paranoid */ verify ( monitors[0]->lock.lock );
 	/* paranoid */ verifyf( monitors[0]->owner == active_thread(), "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), monitors[0]->owner, monitors[0]->recursion, monitors[0] );
-	monitors[0]->owner        = owner;
-	monitors[0]->recursion    = 1;
+	monitors[0]->owner = owner;
+	monitors[0]->recursion = 1;
 	for ( i; 1~count ) {
 		/* paranoid */ verify ( monitors[i]->lock.lock );
 		/* paranoid */ verifyf( monitors[i]->owner == active_thread(), "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), monitors[i]->owner, monitors[i]->recursion, monitors[i] );
-		monitors[i]->owner        = owner;
-		monitors[i]->recursion    = 0;
+		monitors[i]->owner = owner;
+		monitors[i]->recursion = 0;
 	}
 }
@@ -765,5 +765,5 @@
 static inline thread$ * next_thread( monitor$ * this ) {
 	//Check the signaller stack
-	__cfaabi_dbg_print_safe( "Kernel :  mon %p AS-stack top %p\n", this, this->signal_stack.top);
+	__cfaabi_dbg_print_safe( "Kernel : mon %p AS-stack top %p\n", this, this->signal_stack.top);
 	__condition_criterion_t * urgent = pop( this->signal_stack );
 	if ( urgent ) {
@@ -771,6 +771,6 @@
 		//regardless of if we are ready to baton pass,
 		//we need to set the monitor as in use
-		/* paranoid */ verifyf( !this->owner || active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
-		__set_owner( this,  urgent->owner->waiting_thread );
+		/* paranoid */ verifyf( ! this->owner || active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
+		__set_owner( this, urgent->owner->waiting_thread );
 
 		return check_condition( urgent );
@@ -780,6 +780,6 @@
 	// Get the next thread in the entry_queue
 	thread$ * new_owner = pop_head( this->entry_queue );
-	/* paranoid */ verifyf( !this->owner || active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
-	/* paranoid */ verify( !new_owner || new_owner->user_link.next == 0p );
+	/* paranoid */ verifyf( ! this->owner || active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
+	/* paranoid */ verify( ! new_owner || new_owner->user_link.next == 0p );
 	__set_owner( this, new_owner );
 
@@ -792,5 +792,5 @@
 
 	// Check if there are any acceptable functions
-	if ( !it ) return false;
+	if ( ! it ) return false;
 
 	// If this isn't the first monitor to test this, there is no reason to repeat the test.
@@ -820,5 +820,5 @@
 	for ( i; count ) {
 		(criteria[i]){ monitors[i], waiter };
-		__cfaabi_dbg_print_safe( "Kernel :  target %p = %p\n", criteria[i].target, &criteria[i] );
+		__cfaabi_dbg_print_safe( "Kernel : target %p = %p\n", criteria[i].target, &criteria[i] );
 		push( criteria[i].target->signal_stack, &criteria[i] );
 	}
@@ -902,5 +902,5 @@
 	}
 
-	__cfaabi_dbg_print_safe( "Kernel :  Runing %i (%p)\n", ready2run, ready2run ? (thread*)node->waiting_thread : (thread*)0p );
+	__cfaabi_dbg_print_safe( "Kernel : Runing %i (%p)\n", ready2run, ready2run ? (thread*)node->waiting_thread : (thread*)0p );
 	return ready2run ? node->waiting_thread : 0p;
 }
@@ -908,5 +908,5 @@
 static inline void brand_condition( condition & this ) {
 	thread$ * thrd = active_thread();
-	if ( !this.monitors ) {
+	if ( ! this.monitors ) {
 		// __cfaabi_dbg_print_safe( "Branding\n" );
 		assertf( thrd->monitors.data != 0p, "No current monitor to brand condition %p", thrd->monitors.data );
@@ -928,5 +928,5 @@
 	for ( __acceptable_t * it = begin; it != end; it++, i++ ) {
 		#if defined( __CFA_WITH_VERIFY__ )
-		thread$ * last = 0p;
+		thread$ * prior = 0p;
 		#endif // __CFA_WITH_VERIFY__
 
@@ -934,7 +934,7 @@
 			thread$ * curr = *thrd_it;
 
-			/* paranoid */ verifyf( !last || last->user_link.next == curr, "search not making progress, from %p (%p) to %p",
-									last, last->user_link.next, curr );
-			/* paranoid */ verifyf( curr != last, "search not making progress, from %p to %p", last, curr );
+			/* paranoid */ verifyf( ! prior || prior->user_link.next == curr, "search not making progress, from %p (%p) to %p",
+									prior, prior->user_link.next, curr );
+			/* paranoid */ verifyf( curr != prior, "search not making progress, from %p to %p", prior, curr );
 
 			// For each thread in the entry-queue check for a match
@@ -945,5 +945,5 @@
 
 			#if defined( __CFA_WITH_VERIFY__ )
-			last = curr;
+			prior = curr;
 			#endif
 		} // for
@@ -1001,16 +1001,16 @@
 	if ( unlikely(0 != (0x1 & (uintptr_t)this->owner)) ) {
 		abort( "Attempt by thread \"%.256s\" (%p) to access joined monitor %p.", thrd->self_cor.name, thrd, this );
-	} else if ( !this->owner ) {
+	} else if ( ! this->owner ) {
 		// No one has the monitor, just take it
 		__set_owner( this, thrd );
 
-		__cfaabi_dbg_print_safe( "Kernel :  mon is free \n" );
+		__cfaabi_dbg_print_safe( "Kernel : mon is free \n" );
 	} else if ( this->owner == thrd) {
 		// We already have the monitor, just note how many times we took it
 		this->recursion += 1;
 
-		__cfaabi_dbg_print_safe( "Kernel :  mon already owned \n" );
+		__cfaabi_dbg_print_safe( "Kernel : mon already owned \n" );
 	} else {
-		__cfaabi_dbg_print_safe( "Kernel :  blocking \n" );
+		__cfaabi_dbg_print_safe( "Kernel : blocking \n" );
 
 		// Some one else has the monitor, wait in line for it
@@ -1022,5 +1022,5 @@
 		park();
 
-		__cfaabi_dbg_print_safe( "Kernel : %10p Entered  mon %p\n", thrd, this);
+		__cfaabi_dbg_print_safe( "Kernel : %10p Entered mon %p\n", thrd, this);
 
 		/* paranoid */ verifyf( active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
@@ -1028,5 +1028,5 @@
 	}
 
-	__cfaabi_dbg_print_safe( "Kernel : %10p Entered  mon %p\n", thrd, this);
+	__cfaabi_dbg_print_safe( "Kernel : %10p Entered mon %p\n", thrd, this);
 
 	/* paranoid */ verifyf( active_thread() == this->owner, "Expected owner to be %p, got %p (r: %i, m: %p)", active_thread(), this->owner, this->recursion, this );
Index: libcfa/src/concurrency/preemption.cfa
===================================================================
--- libcfa/src/concurrency/preemption.cfa	(revision c5e1aa6010a41c286b6f179da6348411941b89b2)
+++ libcfa/src/concurrency/preemption.cfa	(revision 579427b5dae492c357e172f3e2f17af585f77f00)
@@ -10,6 +10,6 @@
 // Created On       : Mon Jun 5 14:20:42 2017
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Jan  9 08:42:59 2023
-// Update Count     : 60
+// Last Modified On : Fri Apr 25 07:24:39 2025
+// Update Count     : 63
 //
 
@@ -39,5 +39,5 @@
 __attribute__((weak)) Duration default_preemption() libcfa_public {
 	const char * preempt_rate_s = getenv("CFA_DEFAULT_PREEMPTION");
-	if(!preempt_rate_s) {
+	if ( !preempt_rate_s) {
 		__cfadbg_print_safe(preemption, "No CFA_DEFAULT_PREEMPTION in ENV\n");
 		return __CFA_DEFAULT_PREEMPTION__;
@@ -46,9 +46,9 @@
 	char * endptr = 0p;
 	long int preempt_rate_l = strtol(preempt_rate_s, &endptr, 10);
-	if(preempt_rate_l < 0 || preempt_rate_l > 65535) {
+	if (preempt_rate_l < 0 || preempt_rate_l > 65535) {
 		__cfadbg_print_safe(preemption, "CFA_DEFAULT_PREEMPTION out of range : %ld\n", preempt_rate_l);
 		return __CFA_DEFAULT_PREEMPTION__;
 	}
-	if('\0' != *endptr) {
+	if ('\0' != *endptr) {
 		__cfadbg_print_safe(preemption, "CFA_DEFAULT_PREEMPTION not a decimal number : %s\n", preempt_rate_s);
 		return __CFA_DEFAULT_PREEMPTION__;
@@ -64,9 +64,9 @@
 // FwdDeclarations : Signal handlers
 static void sigHandler_ctxSwitch( __CFA_SIGPARMS__ );
-static void sigHandler_alarm    ( __CFA_SIGPARMS__ );
-static void sigHandler_segv     ( __CFA_SIGPARMS__ );
-static void sigHandler_ill      ( __CFA_SIGPARMS__ );
-static void sigHandler_fpe      ( __CFA_SIGPARMS__ );
-static void sigHandler_abort    ( __CFA_SIGPARMS__ );
+static void sigHandler_alarm( __CFA_SIGPARMS__ );
+static void sigHandler_segv( __CFA_SIGPARMS__ );
+static void sigHandler_ill( __CFA_SIGPARMS__ );
+static void sigHandler_fpe( __CFA_SIGPARMS__ );
+static void sigHandler_abort( __CFA_SIGPARMS__ );
 
 // FwdDeclarations : alarm thread main
@@ -86,8 +86,8 @@
 #endif
 
-KERNEL_STORAGE(event_kernel_t, event_kernel);         // private storage for event kernel
-event_kernel_t * event_kernel;                        // kernel public handle to even kernel
-static pthread_t alarm_thread;                        // pthread handle to alarm thread
-static void * alarm_stack;							  // pthread stack for alarm thread
+KERNEL_STORAGE(event_kernel_t, event_kernel);			// private storage for event kernel
+event_kernel_t * event_kernel;							// kernel public handle to even kernel
+static pthread_t alarm_thread;							// pthread handle to alarm thread
+static void * alarm_stack;								// pthread stack for alarm thread
 
 static void ?{}(event_kernel_t & this) with( this ) {
@@ -102,7 +102,7 @@
 // Get next expired node
 static inline alarm_node_t * get_expired( alarm_list_t * alarms, Time currtime ) {
-	if( ! & (*alarms)`first ) return 0p;						// If no alarms return null
-	if( (*alarms)`first.deadline >= currtime ) return 0p;	// If alarms head not expired return null
-	return pop(alarms);									// Otherwise just pop head
+	if ( ! & first( *alarms ) ) return 0p;				  // If no alarms return null
+	if ( first( *alarms ).deadline >= currtime ) return 0p; // If alarms head not expired return null
+	return pop(alarms);									  // Otherwise just pop head
 }
 
@@ -117,6 +117,6 @@
 		__cfadbg_print_buffer_decl( preemption, " KERNEL: preemption tick %lu\n", currtime.tn);
 		Duration period = node->period;
-		if( period == 0 ) {
-			node->set = false;                  // Node is one-shot, just mark it as not pending
+		if ( period == 0 ) {
+			node->set = false;				  // Node is one-shot, just mark it as not pending
 		}
 
@@ -125,8 +125,8 @@
 
 		// Check if this is a kernel
-		if( node->type == Kernel ) {
+		if ( node->type == Kernel ) {
 			preempt( node->proc );
 		}
-		else if( node->type == User ) {
+		else if ( node->type == User ) {
 			__cfadbg_print_buffer_local( preemption, " KERNEL: alarm unparking %p.\n", node->thrd );
 			timeout( node->thrd );
@@ -137,14 +137,14 @@
 
 		// Check if this is a periodic alarm
-		if( period > 0 ) {
+		if ( period > 0 ) {
 			__cfadbg_print_buffer_local( preemption, " KERNEL: alarm period is %lu.\n", period`ns );
 			node->deadline = currtime + period;  // Alarm is periodic, add currtime to it (used cached current time)
-			insert( alarms, node );             // Reinsert the node for the next time it triggers
+			insert( alarms, node );			 // Reinsert the node for the next time it triggers
 		}
 	}
 
 	// If there are still alarms pending, reset the timer
-	if( & (*alarms)`first ) {
-		Duration delta = (*alarms)`first.deadline - currtime;
+	if ( & first( *alarms ) ) {
+		Duration delta = first( *alarms ).deadline - currtime;
 		__kernel_set_timer( delta );
 	}
@@ -283,5 +283,5 @@
 		__attribute__((unused)) unsigned short new_val = disable_count + 1;
 		disable_count = new_val;
-		verify( new_val < 65_000u );              // If this triggers someone is disabling interrupts without enabling them
+		verify( new_val < 65_000u );			  // If this triggers someone is disabling interrupts without enabling them
 	}
 
@@ -301,5 +301,5 @@
 
 			// Check if we need to prempt the thread because an interrupt was missed
-			if( prev == 1 ) {
+			if ( prev == 1 ) {
 				#if GCC_VERSION > 50000
 					static_assert(__atomic_always_lock_free(sizeof(enabled), &enabled), "Must be lock-free");
@@ -313,5 +313,5 @@
 				// Signal the compiler that a fence is needed but only for signal handlers
 				__atomic_signal_fence(__ATOMIC_RELEASE);
-				if( poll && proc->pending_preemption ) {
+				if ( poll && proc->pending_preemption ) {
 					proc->pending_preemption = false;
 					force_yield( __POLL_PREEMPTION );
@@ -334,5 +334,5 @@
 		// Signal the compiler that a fence is needed but only for signal handlers
 		__atomic_signal_fence(__ATOMIC_RELEASE);
-		if( unlikely( proc->pending_preemption ) ) {
+		if ( unlikely( proc->pending_preemption ) ) {
 			proc->pending_preemption = false;
 			force_yield( __POLL_PREEMPTION );
@@ -347,22 +347,22 @@
 void __cfaabi_check_preemption() libcfa_public {
 	bool ready = __preemption_enabled();
-	if(!ready) { abort("Preemption should be ready"); }
+	if ( !ready) { abort("Preemption should be ready"); }
 
 	sigset_t oldset;
 	int ret;
 	ret = __cfaabi_pthread_sigmask(0, ( const sigset_t * ) 0p, &oldset);  // workaround trac#208: cast should be unnecessary
-	if(ret != 0) { abort("ERROR sigprocmask returned %d", ret); }
+	if (ret != 0) { abort("ERROR sigprocmask returned %d", ret); }
 
 	ret = sigismember(&oldset, SIGUSR1);
-	if(ret <  0) { abort("ERROR sigismember returned %d", ret); }
-	if(ret == 1) { abort("ERROR SIGUSR1 is disabled"); }
+	if (ret <  0) { abort("ERROR sigismember returned %d", ret); }
+	if (ret == 1) { abort("ERROR SIGUSR1 is disabled"); }
 
 	ret = sigismember(&oldset, SIGALRM);
-	if(ret <  0) { abort("ERROR sigismember returned %d", ret); }
-	if(ret == 0) { abort("ERROR SIGALRM is enabled"); }
+	if (ret <  0) { abort("ERROR sigismember returned %d", ret); }
+	if (ret == 0) { abort("ERROR SIGALRM is enabled"); }
 
 	ret = sigismember(&oldset, SIGTERM);
-	if(ret <  0) { abort("ERROR sigismember returned %d", ret); }
-	if(ret == 1) { abort("ERROR SIGTERM is disabled"); }
+	if (ret <  0) { abort("ERROR sigismember returned %d", ret); }
+	if (ret == 1) { abort("ERROR SIGTERM is disabled"); }
 }
 
@@ -385,5 +385,5 @@
 
 	if ( __cfaabi_pthread_sigmask( SIG_UNBLOCK, &mask, 0p ) == -1 ) {
-	    abort( "internal error, pthread_sigmask" );
+		abort( "internal error, pthread_sigmask" );
 	}
 }
@@ -415,13 +415,13 @@
 	int ret;
 	ret = __cfaabi_pthread_sigmask(0, ( const sigset_t * ) 0p, &oldset);  // workaround trac#208: cast should be unnecessary
-	if(ret != 0) { abort("ERROR sigprocmask returned %d", ret); }
+	if (ret != 0) { abort("ERROR sigprocmask returned %d", ret); }
 
 	ret = sigismember(&oldset, SIGUSR1);
-	if(ret <  0) { abort("ERROR sigismember returned %d", ret); }
-	if(ret == 1) { abort("ERROR SIGUSR1 is disabled"); }
+	if (ret <  0) { abort("ERROR sigismember returned %d", ret); }
+	if (ret == 1) { abort("ERROR SIGUSR1 is disabled"); }
 
 	ret = sigismember(&oldset, SIGALRM);
-	if(ret <  0) { abort("ERROR sigismember returned %d", ret); }
-	if(ret == 0) { abort("ERROR SIGALRM is enabled"); }
+	if (ret <  0) { abort("ERROR sigismember returned %d", ret); }
+	if (ret == 0) { abort("ERROR SIGALRM is enabled"); }
 
 	signal_block( SIGUSR1 );
@@ -434,13 +434,13 @@
 	int ret;
 	ret = __cfaabi_pthread_sigmask(0, ( const sigset_t * ) 0p, &oldset);  // workaround trac#208: cast should be unnecessary
-	if(ret != 0) { abort("ERROR sigprocmask returned %d", ret); }
+	if (ret != 0) { abort("ERROR sigprocmask returned %d", ret); }
 
 	ret = sigismember(&oldset, SIGUSR1);
-	if(ret <  0) { abort("ERROR sigismember returned %d", ret); }
-	if(ret == 1) { abort("ERROR SIGUSR1 is disabled"); }
+	if (ret <  0) { abort("ERROR sigismember returned %d", ret); }
+	if (ret == 1) { abort("ERROR SIGUSR1 is disabled"); }
 
 	ret = sigismember(&oldset, SIGALRM);
-	if(ret <  0) { abort("ERROR sigismember returned %d", ret); }
-	if(ret == 0) { abort("ERROR SIGALRM is enabled"); }
+	if (ret <  0) { abort("ERROR sigismember returned %d", ret); }
+	if (ret == 0) { abort("ERROR SIGALRM is enabled"); }
 }
 
@@ -453,9 +453,9 @@
 	// Check if preemption is safe
 	bool ready = true;
-	if( __cfaabi_in( ip, __libcfa_nopreempt ) ) { ready = false; goto EXIT; };
-	if( __cfaabi_in( ip, __libcfathrd_nopreempt ) ) { ready = false; goto EXIT; };
-
-	if( !__cfaabi_tls.preemption_state.enabled) { ready = false; goto EXIT; };
-	if( __cfaabi_tls.preemption_state.in_progress ) { ready = false; goto EXIT; };
+	if ( __cfaabi_in( ip, __libcfa_nopreempt ) ) { ready = false; goto EXIT; };
+	if ( __cfaabi_in( ip, __libcfathrd_nopreempt ) ) { ready = false; goto EXIT; };
+
+	if ( !__cfaabi_tls.preemption_state.enabled) { ready = false; goto EXIT; };
+	if ( __cfaabi_tls.preemption_state.in_progress ) { ready = false; goto EXIT; };
 
 EXIT:
@@ -484,5 +484,5 @@
 	// Setup proper signal handlers
 	__cfaabi_sigaction( SIGUSR1, sigHandler_ctxSwitch, SA_SIGINFO ); // __cfactx_switch handler
-	__cfaabi_sigaction( SIGALRM, sigHandler_alarm    , SA_SIGINFO ); // debug handler
+	__cfaabi_sigaction( SIGALRM, sigHandler_alarm , SA_SIGINFO ); // debug handler
 
 	signal_block( SIGALRM );
@@ -551,9 +551,9 @@
 	// before the kernel thread has even started running. When that happens, an interrupt
 	// with a null 'this_processor' will be caught, just ignore it.
-	if(! __cfaabi_tls.this_processor ) return;
+	if ( ! __cfaabi_tls.this_processor ) return;
 
 	choose(sfp->si_value.sival_int) {
-		case PREEMPT_NORMAL   : ;// Normal case, nothing to do here
-		case PREEMPT_IO       : ;// I/O asked to stop spinning, nothing to do here
+		case PREEMPT_NORMAL: ;							// Normal case, nothing to do here
+		case PREEMPT_IO: ;								// I/O asked to stop spinning, nothing to do here
 		case PREEMPT_TERMINATE: verify( __atomic_load_n( &__cfaabi_tls.this_processor->do_terminate, __ATOMIC_SEQ_CST ) );
 		default:
@@ -562,5 +562,5 @@
 
 	// Check if it is safe to preempt here
-	if( !preemption_ready( ip ) ) {
+	if ( !preemption_ready( ip ) ) {
 		#if !defined(__CFA_NO_STATISTICS__)
 			__cfaabi_tls.this_stats->ready.threads.preempt.rllfwd++;
@@ -607,5 +607,5 @@
 	sigfillset(&mask);
 	if ( __cfaabi_pthread_sigmask( SIG_BLOCK, &mask, 0p ) == -1 ) {
-	    abort( "internal error, pthread_sigmask" );
+		abort( "internal error, pthread_sigmask" );
 	}
 
@@ -622,5 +622,5 @@
 		__cfadbg_print_buffer_local( preemption, " KERNEL: SI_QUEUE %d, SI_TIMER %d, SI_KERNEL %d\n", SI_QUEUE, SI_TIMER, SI_KERNEL );
 
-		if( sig < 0 ) {
+		if ( sig < 0 ) {
 			//Error!
 			int err = errno;
Index: libcfa/src/concurrency/pthread.cfa
===================================================================
--- libcfa/src/concurrency/pthread.cfa	(revision c5e1aa6010a41c286b6f179da6348411941b89b2)
+++ libcfa/src/concurrency/pthread.cfa	(revision 579427b5dae492c357e172f3e2f17af585f77f00)
@@ -9,7 +9,7 @@
 // Author           : Zhenyan Zhu
 // Created On       : Sat Aug 6 16:29:18 2022
-// Last Modified By : Kyoung Seo
-// Last Modified On : Mon Jan 27 20:35:00 2025
-// Update Count     : 1
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Fri Apr 25 07:28:01 2025
+// Update Count     : 4
 //
 
@@ -40,5 +40,5 @@
 	bool in_use;
 	void (* destructor)( void * );
-    dlist( pthread_values ) threads;
+	dlist( pthread_values ) threads;
 };
 
@@ -543,9 +543,7 @@
 		// 	p.in_use = false;
 		// }
-        pthread_values * p = &try_pop_front( cfa_pthread_keys[key].threads );
-        for ( ; p; ) {            
-            p->in_use = false;
-            p = &try_pop_front( cfa_pthread_keys[key].threads );
-        }
+		for ( pthread_values * p = &remove_first( cfa_pthread_keys[key].threads ); p; p = &remove_first( cfa_pthread_keys[key].threads ) ) {
+			p->in_use = false;
+		}
 		unlock(key_lock);
 		return 0;
@@ -603,8 +601,7 @@
 	//######################### Parallelism #########################
 	void pthread_delete_kernel_threads_() __THROW {	// see uMain::~uMain
-		Pthread_kernel_threads * p = &try_pop_front(cfa_pthreads_kernel_threads);
-		for ( ; p; ) {
-            delete(p);
-			p = &try_pop_front(cfa_pthreads_kernel_threads);
+		
+		for ( Pthread_kernel_threads * p = &remove_first(cfa_pthreads_kernel_threads); p; p = &remove_first(cfa_pthreads_kernel_threads) ) {
+			delete(p);
 		} // for
 	} // pthread_delete_kernel_threads_
@@ -626,5 +623,5 @@
 		} // for
 		for ( ; new_level < cfa_pthreads_no_kernel_threads; cfa_pthreads_no_kernel_threads -= 1 ) { // remove processors ?
-			delete(&try_pop_front(cfa_pthreads_kernel_threads));
+			delete(&remove_first(cfa_pthreads_kernel_threads));
 		} // for
 		unlock( concurrency_lock );
